Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

- Main Page
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | Related Functions
openvrml::vec2d Struct Reference

Two-component double-precision vector. More...

`#include <openvrml/basetypes.h>`

List of all members.

## Public Member Functions

vec2d & | operator*= (double scalar) throw ()
| Multiply by a scalar.
vec2d & | operator/= (double scalar) throw ()
| Divide by a scalar.
vec2d & | operator+= (const vec2d &vec) throw ()
| Add a vector.
vec2d & | operator-= (const vec2d &vec) throw ()
| Subtract a vector.
const vec2d | operator- () const throw ()
| Negate.
const double & | operator[] (std::size_t index) const throw ()
| Index-based component access.
double | x () const throw ()
| Get the x component.
void | x (double value) throw ()
| Set the x component.
double | y () const throw ()
| Get the y component.
void | y (double value) throw ()
| Set the y component.
double | dot (const vec2d &vec) const throw ()
| Dot product.
double | length () const throw ()
| Geometric length.
const vec2d | normalize () const throw ()
| Normalize.

## Public Attributes

double | vec [2]
| Vector components.

## Related Functions

(Note that these are not member functions.)
const openvrml::vec2d | make_vec2d () throw()
| Create a `vec2d`.
const openvrml::vec2d | make_vec2d (const double(&vec)[2]) throw()
| Create a `vec2d` from an array.
const openvrml::vec2d | make_vec2d (const double x, const double y) throw()
| Create a `vec2d` from `x` and `y` components.
const openvrml::vec2d | operator* (const vec2d &lhs, const double rhs) throw()
| Multiply a vector by a scalar.
const openvrml::vec2d | operator* (const double lhs, const vec2d &rhs) throw()
| Multiply a vector by a scalar.
const openvrml::vec2d | operator/ (const vec2d &lhs, const double rhs) throw()
| Divide a vector by a scalar.
const openvrml::vec2d | operator+ (const vec2d &lhs, const vec2d &rhs) throw()
| Add two vectors.
const openvrml::vec2d | operator- (const vec2d &lhs, const vec2d &rhs) throw()
| Subtract two vectors.
bool | operator== (const vec2d &lhs, const vec2d &rhs) throw()
| Compare for equality.
bool | operator!= (const vec2d &lhs, const vec2d &rhs) throw()
| Compare for inequality.
std::istream & | operator>> (std::istream &in, vec2d &v)
| Stream input.
std::ostream & | operator<< (std::ostream &out, const vec2d &v)
| Stream output.

## Detailed Description

Two-component double-precision vector.

## Member Function Documentation

openvrml::vec2d & openvrml::vec2d::operator*= | ( | double | scalar | ) | throw ()

Multiply by a scalar.

Parameters:

  [in] | scalar | factor by which to multiply.

Returns:
  a reference to the object.

openvrml::vec2d & openvrml::vec2d::operator/= | ( | double | scalar | ) | throw ()

Divide by a scalar.

Precondition:
  `scalar` is nonzero.

Parameters:

  [in] | scalar | divisor.

Returns:
  a reference to the object.

openvrml::vec2d & openvrml::vec2d::operator+= | ( | const vec2d & | vec | ) | throw ()

Add a vector.

Parameters:

  [in] | vec | the vector to add.

Returns:
  a reference to the object.

openvrml::vec2d & openvrml::vec2d::operator-= | ( | const vec2d & | vec | ) | throw ()

Subtract a vector.

Parameters:

  [in] | vec | the vector to subtract.

Returns:
  a reference to the object.

const openvrml::vec2d openvrml::vec2d::operator- | ( |  | ) | const throw ()

Negate.

Returns:
  the additive inverse of the vector.

const double & openvrml::vec2d::operator[] | ( | std::size_t | index | ) | const throw ()`[inline]`

Index-based component access.

Parameters:

  [in] | index | 0 corresponds to the x component; 1 corresponds to the y component.

Returns:
  a const reference to the component corresponding to `index`.

Precondition:
  `index` is less than 2.

double openvrml::vec2d::x | ( |  | ) | const throw ()`[inline]`

Get the x component.

Returns:
  the x component.

void openvrml::vec2d::x | ( | double | value | ) | throw ()`[inline]`

Set the x component.

Precondition:
  `value` is a valid numeric value (i.e., not NaN).

Parameters:

  [in] | value | new x component value.

double openvrml::vec2d::y | ( |  | ) | const throw ()`[inline]`

Get the y component.

Returns:
  the y component.

void openvrml::vec2d::y | ( | double | value | ) | throw ()`[inline]`

Set the y component.

Precondition:
  `value` is a valid numeric value (i.e., not NaN).

Parameters:

  [in] | value | new y component value.

double openvrml::vec2d::dot | ( | const vec2d & | vec | ) | const throw ()

Dot product.

Parameters:

  [in] | vec |

Returns:
  the dot product of the vector and `vec`.

double openvrml::vec2d::length | ( |  | ) | const throw ()

Geometric length.

Returns:
  the length of the vector.

const openvrml::vec2d openvrml::vec2d::normalize | ( |  | ) | const throw ()

Normalize.

Returns:
  the vector normalized.

## Friends And Related Function Documentation

const openvrml::vec2d make_vec2d | ( |  | ) | throw()`[related]`

Create a `vec2d`.

Returns:
  a zero-initialized `vec2d`.

const openvrml::vec2d make_vec2d | ( | const double(&) | vec[2] | ) | throw()`[related]`

Create a `vec2d` from an array.

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Precondition:
  Elements of `vec` are valid numeric values (i.e., not NaN).

Parameters:

  [in] | vec | an array comprising the vector components.

Returns:
  a `vec2d` with the values in `vec`.

const openvrml::vec2d make_vec2d | ( | const double | x,
|  | const double | y
| ) |  | throw()`[related]`

Create a `vec2d` from `x` and `y` components.

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Precondition:
  `x` and `y` are valid numeric values (i.e., not NaN).

Parameters:

  [in] | x | x component.
  [in] | y | y component.

Returns:
  a `vec2d` with the values `x` and `y`.

const openvrml::vec2d operator* | ( | const vec2d & | lhs,
|  | const double | rhs
| ) |  | throw()`[related]`

Multiply a vector by a scalar.

Parameters:

  [in] | lhs | left-hand operand (the vector).
  [in] | rhs | right-hand operand (the scalar).

Returns:
  the result vector.

const openvrml::vec2d operator* | ( | const double | lhs,
|  | const vec2d & | rhs
| ) |  | throw()`[related]`

Multiply a vector by a scalar.

Parameters:

  [in] | lhs | left-hand operand (the scalar).
  [in] | rhs | right-hand operand (the vector).

Returns:
  the result vector.

const openvrml::vec2d operator/ | ( | const vec2d & | lhs,
|  | const double | rhs
| ) |  | throw()`[related]`

Divide a vector by a scalar.

Precondition:
  `rhs` is nonzero.

Parameters:

  [in] | lhs | left-hand operand (the vector).
  [in] | rhs | right-hand operand (the scalar).

Returns:
  the result vector.

const openvrml::vec2d operator+ | ( | const vec2d & | lhs,
|  | const vec2d & | rhs
| ) |  | throw()`[related]`

Add two vectors.

Parameters:

  [in] | lhs | left-hand operand.
  [in] | rhs | right-hand operand.

Returns:
  the result vector.

const openvrml::vec2d operator- | ( | const vec2d & | lhs,
|  | const vec2d & | rhs
| ) |  | throw()`[related]`

Subtract two vectors.

Parameters:

  [in] | lhs | left-hand operand.
  [in] | rhs | right-hand operand.

Returns:
  the result vector.

bool operator== | ( | const vec2d & | lhs,
|  | const vec2d & | rhs
| ) |  | throw()`[related]`

Compare for equality.

Parameters:

  [in] | lhs | left-hand operand.
  [in] | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const vec2d & | lhs,
|  | const vec2d & | rhs
| ) |  | throw()`[related]`

Compare for inequality.

Parameters:

  [in] | lhs | left-hand operand.
  [in] | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` dot not have the same value; `false` otherwise.

std::istream & operator>> | ( | std::istream & | in,
|  | vec2d & | v
| ) |  | `[related]`

Stream input.

Consistent with the VRML97 convention, commas (“``,”) in the input are treated as whitespace.

Parameters:

  [in,out] | in | input stream.
  [out] | v | a `vec2d`.

Returns:
  `in`.

std::ostream & operator<< | ( | std::ostream & | out,
|  | const vec2d & | v
| ) |  | `[related]`

Stream output.

Parameters:

  [in,out] | out | output stream.
  [in] | v | a 2-component vector.

Returns:
  `out`.

## Member Data Documentation

double openvrml::vec2d::vec[2]

Vector components.